"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
var Collection = /** @class */ (function () {
    function Collection(items) {
        if (items === void 0) { items = []; }
        this.changed = false;
        this.items = items;
        this.changed = true;
    }
    Collection.prototype.size = function () {
        return this.items.length;
    };
    Collection.prototype.add = function (value) {
        this.changed = true;
        this.items.push(value);
    };
    Collection.prototype.remove = function (index) {
        this.changed = true;
        this.items.splice(index, 1);
    };
    Collection.prototype.where = function (func) {
        var _this = this;
        var arr = [];
        this.items.forEach(function (item, index) {
            if (func.apply(_this, [item])) {
                arr.push(index);
            }
        });
        return arr;
    };
    Collection.prototype.removeWhere = function (field, value) {
        var indexes = this.where(function (item) {
            return item[field] == value;
        });
        for (var i in indexes) {
            this.remove(indexes[i]);
        }
    };
    Object.defineProperty(Collection.prototype, "data", {
        get: function () {
            return this;
        },
        enumerable: true,
        configurable: true
    });
    Collection.prototype.get = function (index) {
        return this.items[index];
    };
    Collection.prototype.setItems = function (items) {
        this.items = items;
    };
    Collection.prototype.getItems = function () {
        return this.items;
    };
    Collection.prototype.getItemsObservable = function (interval) {
        var _this = this;
        if (interval === void 0) { interval = 1000; }
        return new rxjs_1.Observable(function (observer) {
            setInterval(function () {
                if (_this.changed) {
                    _this.changed = false;
                    observer.next(_this.getItems());
                }
            }, interval);
        });
    };
    Collection.prototype.toArray = function () {
        var arr = [];
        this.items.forEach(function (item) {
            arr.push(item.all());
        });
        return arr;
    };
    return Collection;
}());
exports.Collection = Collection;
//# sourceMappingURL=collection.js.map