"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var ErrorComponent = /** @class */ (function () {
    function ErrorComponent(cd) {
        this.cd = cd;
        this.errors = {};
    }
    ErrorComponent.prototype.ngOnInit = function () {
        var _this = this;
        if (this.intervalCheckErrors) {
            clearInterval(this.intervalCheckErrors);
        }
        this.intervalCheckErrors = setInterval(function () {
            var compare = _this.errors.toString();
            _this.errors = _this.data.formControl.errors || {};
            if (compare != _this.errors.toString()) {
                _this.cd.detectChanges();
            }
        }, 100);
    };
    ErrorComponent.prototype.ngOnDestroy = function () {
        if (this.intervalCheckErrors) {
            clearInterval(this.intervalCheckErrors);
        }
    };
    ErrorComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'gc-form-element-error',
                    template: "\n        <div *ngIf=\"errors.required\">\n            The {{ data.field.label }} field is required.\n        </div>\n\n        <div *ngIf=\"!errors.required && errors.minlength\">\n            The {{ data.field.label }} must be at least {{errors.minlength.requiredLength}} characters.\n        </div>\n\n        <div *ngIf=\"errors.maxlength\">\n            The {{ data.field.label }} may not be greater than {{errors.maxlength.requiredLength}} characters.\n        </div>\n\n        <div *ngIf=\"!errors.required && errors.min\">\n            The {{ data.field.label }} must be at least {{errors.min.min}}.\n        </div>\n\n        <div *ngIf=\"errors.max\">\n            The {{ data.field.label }} may not be greater than {{errors.max.max}}.\n        </div>\n\n        <div *ngIf=\"!errors.required && errors.email\">\n            The {{ data.field.label }} must be a valid email address.\n        </div>\n    "
                },] },
    ];
    /** @nocollapse */
    ErrorComponent.ctorParameters = function () { return [
        { type: core_1.ChangeDetectorRef, },
    ]; };
    ErrorComponent.propDecorators = {
        'data': [{ type: core_1.Input, args: ['data',] },],
    };
    return ErrorComponent;
}());
exports.ErrorComponent = ErrorComponent;
//# sourceMappingURL=error.component.js.map