import { OnInit } from '@angular/core';
import { MasksService } from '../masks.service';
import { FormControl, FormGroup } from '@angular/forms';
import { Model } from "../../../models/model";
import { Element, ElementConfig } from "../form-element.component";
import { ValidatorsService } from "../validators.service";
export interface DataElement {
    form: FormGroup;
    model: Model;
    field: Element;
    config: ElementConfig;
    controlName: string;
    formControl: FormControl;
    events?: any;
}
export declare class BaseElement implements OnInit {
    data: DataElement;
    protected hasMask: boolean;
    protected validatorsService: ValidatorsService;
    protected masksService: MasksService;
    protected _mask: any;
    _fn_onKeyPress: any;
    _fn_onKeyUp: any;
    _fn_onChange: any;
    _fn_onBlur: any;
    constructor();
    ngOnInit(): void;
    parseData(): void;
    registerOutputEvents(): void;
    registerEvent(name: string, fn: ($event: any, value: any) => void): void;
    triggerEvent(name: string, $event: any, value: any): void;
    getEventValue($event: any): any;
    onKeyUp($event: KeyboardEvent): void;
    onKeyPress($event: KeyboardEvent): void;
    onChange($event: Event): void;
    onBlur($event: FocusEvent): void;
    value: any;
    createMask(): any;
    readonly mask: any;
    applyMask(val: any): any;
    unmask(val: any): any;
    hasHint(align: string): boolean;
    getHint(align: any): any;
}
