"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var base_1 = require("../base");
/*
Input	readonly	boolean	false	Enabled / disable readonly on editor
Input	skin	string	'moono-lisa'	Set the editor skin
Input	language	string	'en'	Set the editor language
Input	fullPage	boolean	false	Enalbed /disable fullPage mode on editor
Input	config	object	{}	CKEditor's config object, see more
* */
var CkeditorComponent = /** @class */ (function (_super) {
    __extends(CkeditorComponent, _super);
    function CkeditorComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.config = {
            height: 500,
            skin: 'moono-lisa',
            toolbarGroups: [
                { name: 'document', groups: ['document', 'mode', 'doctools'] },
                { name: 'clipboard', groups: ['undo', 'clipboard'] },
                { name: 'forms', groups: ['forms'] },
                { name: 'insert', groups: ['insert'] },
                { name: 'editing', groups: ['find', 'selection', 'spellchecker', 'editing'] },
                { name: 'paragraph', groups: ['list', 'indent', 'blocks', 'align', 'bidi', 'paragraph'] },
                { name: 'basicstyles', groups: ['cleanup', 'basicstyles'] },
                '/',
                { name: 'styles', groups: ['styles'] },
                { name: 'links', groups: ['links'] },
                { name: 'colors', groups: ['colors'] },
                { name: 'tools', groups: ['tools'] },
                { name: 'others', groups: ['others'] },
                { name: 'about', groups: ['about'] }
            ],
            removeButtons: 'Preview,Replace,Find,SelectAll,Textarea,Select,Button,Form,Checkbox,Radio,TextField,ImageButton,HiddenField,NewPage,Save,Source,Templates,Cut,Superscript,Subscript,Strike,BidiLtr,BidiRtl,Language,Anchor,Flash,HorizontalRule,Smiley,SpecialChar,PageBreak,Iframe,ShowBlocks,About,Maximize,CreateDiv'
        };
        return _this;
    }
    CkeditorComponent.prototype.parseData = function () { };
    CkeditorComponent.prototype.onChange = function ($event) {
        if (typeof this.config.onChange == 'function') {
            this.config.onChange($event);
        }
    };
    CkeditorComponent.prototype.onReady = function ($event) {
        if (typeof this.config.onReady == 'function') {
            this.config.onReady($event);
        }
    };
    CkeditorComponent.prototype.onFocus = function ($event) {
        if (typeof this.config.onFocus == 'function') {
            this.config.onFocus($event);
        }
    };
    CkeditorComponent.prototype.onBlur = function ($event) {
        if (typeof this.config.onBlur == 'function') {
            this.config.onBlur($event);
        }
    };
    CkeditorComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'gc-form-element-ckeditor',
                    template: "\n        <div class=\"mat-form-field  mat-form-field-can-float mat-form-field-should-float \">\n            <span class=\"mat-input-placeholder-wrapper mat-form-field-placeholder-wrapper\">\n                <label class=\"mat-input-placeholder mat-form-field-placeholder\" for=\"mat-input-2\" aria-owns=\"mat-input-2\">{{data.field.placeholder}}</label>\n            </span>\n            <ckeditor\n                    [(ngModel)]=\"value\"\n                    [config]=\"config\"\n                    [readonly]=\"false\"\n                    (change)=\"onChange($event)\"\n                    (ready)=\"onReady($event)\"\n                    (focus)=\"onFocus($event)\"\n                    (blur)=\"onBlur($event)\"\n                    debounce=\"500\">\n            </ckeditor>\n        </div>\n    "
                },] },
    ];
    /** @nocollapse */
    CkeditorComponent.ctorParameters = function () { return []; };
    return CkeditorComponent;
}(base_1.BaseElement));
exports.CkeditorComponent = CkeditorComponent;
//# sourceMappingURL=ckeditor.component.js.map