"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var material_1 = require("@angular/material");
var index_1 = require("../../../../models/index");
var rxjs_1 = require("rxjs");
var base_1 = require("../base");
var form_element_control_service_1 = require("../../form-element-control.service");
var masks_service_1 = require("../../masks.service");
var validators_service_1 = require("../../validators.service");
var list_service_1 = require("./list.service");
var BaseList = /** @class */ (function (_super) {
    __extends(BaseList, _super);
    function BaseList(dialog, controlService, listService, validatorsService, masksService) {
        var _this = _super.call(this) || this;
        _this.dialog = dialog;
        _this.controlService = controlService;
        _this.listService = listService;
        _this.validatorsService = validatorsService;
        _this.masksService = masksService;
        _this._config = {
            appendToBody: true,
            keepOpen: false,
            maxItems: Infinity,
            focusFirstElement: false,
            addOnBlur: false,
            validators: []
        };
        return _this;
    }
    Object.defineProperty(BaseList.prototype, "config", {
        get: function () {
            return this._config;
        },
        set: function (data) {
            if (data) {
                for (var index in data) {
                    this._config[index] = data[index];
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    BaseList.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.ngOnInit.call(this);
        this.data.config.attribute.options.selectionChange.subscribe(function () {
            _this.filterOptions();
        });
        this.filterOptions();
    };
    BaseList.prototype.parseData = function () {
        this.config = this.data.config.tagInput;
        this.config.validators = this.validatorsService.getValidators(this.data.config.attribute.getValidators());
    };
    BaseList.prototype.getAttribute = function () {
        return this.data.config.attribute;
    };
    Object.defineProperty(BaseList.prototype, "selected", {
        get: function () {
            return this.data.config.attribute.getSelection();
        },
        enumerable: true,
        configurable: true
    });
    BaseList.prototype.filterOptions = function () {
        this.options = this.data.config.attribute.options.getOptionsAvailable();
    };
    BaseList.prototype.isSelected = function (tag) {
        var name = typeof tag == 'string' ? tag : tag.label;
        for (var i = 0, j = this.selected.length; i < j; i++) {
            if (this.selected[i].label.toLowerCase() == name.toLowerCase()) {
                return true;
            }
        }
        return false;
    };
    BaseList.prototype.getOption = function (tag, all) {
        if (all === void 0) { all = false; }
        var name = (typeof tag == 'string' ? tag : tag.label), filter = (all ? this.data.config.attribute.options.items : this.options).filter(function (opt) {
            return opt.label.toLowerCase() == name.toLowerCase();
        });
        return filter.length ? filter[0] : null;
    };
    BaseList.prototype.newOption = function (tag) {
        var name = typeof tag == 'string' ? tag : tag.label, option = new this.listService.variables.list.Option({ label: name, value: name });
        return option;
    };
    BaseList.prototype.setSelection = function (option) {
        if (typeof option.__index == 'undefined') {
            this.data.config.attribute.addOption(option);
        }
        this.data.config.attribute.addSelection(option);
        if (this.data.model) {
            this.data.model[this.data.config.attribute.code] = { 'label': option.label, 'value': option.value };
        }
    };
    BaseList.prototype.onAdd = function (option) { };
    BaseList.prototype.onAdding = function () {
        var _self = this;
        return function (tag) {
            var selected = _self.isSelected(tag);
            tag = selected ? tag : (_self.getOption(tag) || _self.newOption(tag));
            if (!selected) {
                _self.setSelection(tag);
            }
            return rxjs_1.Observable
                .of(undefined)
                .filter(function () { return !selected; })
                .mapTo(tag);
        };
    };
    BaseList.prototype.onRemoving = function () {
        var _self = this;
        return function (tag) {
            var option = _self.getOption(tag, true);
            if (option) {
                if (_self.data.model) {
                    _self.data.model[_self.data.config.attribute.code] = null;
                }
                _self.data.config.attribute.removeSelection(option.__index);
            }
            return rxjs_1.Observable
                .of(index_1.GcOption)
                .mapTo(option);
        };
    };
    /** @nocollapse */
    BaseList.ctorParameters = function () { return [
        { type: material_1.MatDialog, decorators: [{ type: core_1.Inject, args: [material_1.MatDialog,] },] },
        { type: form_element_control_service_1.FormElementControlService, decorators: [{ type: core_1.Inject, args: [form_element_control_service_1.FormElementControlService,] },] },
        { type: list_service_1.ListService, decorators: [{ type: core_1.Inject, args: [list_service_1.ListService,] },] },
        { type: validators_service_1.ValidatorsService, decorators: [{ type: core_1.Inject, args: [validators_service_1.ValidatorsService,] },] },
        { type: masks_service_1.MasksService, decorators: [{ type: core_1.Inject, args: [masks_service_1.MasksService,] },] },
    ]; };
    return BaseList;
}(base_1.BaseElement));
exports.BaseList = BaseList;
//# sourceMappingURL=base-list.js.map