"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var material_1 = require("@angular/material");
var ColorPickerComponent = /** @class */ (function () {
    function ColorPickerComponent(dataDialog, dialogRef) {
        this.dialogRef = dialogRef;
        this.defaultNumberColor = [1];
        this.isRequired = false;
        this.isDisabled = false;
        this.container = 'inline';
        this.colors = [];
        this.data = dataDialog;
        this.color_picker = [{ color: '#000000', ref: 1, value: 1 }];
        for (var i = 1; i <= this.data.maxColors; i++) {
            this.colors.push({ title: i, value: i });
        }
    }
    ColorPickerComponent.prototype.ngOnInit = function () { };
    ColorPickerComponent.prototype.change = function (event, teste) { };
    ColorPickerComponent.prototype.onChangeSelect = function (event) {
        this.color_picker = [];
        for (var i = 1; i <= event.value; i++) {
            this.color_picker.push({ color: '#000000', ref: i, value: 1 });
        }
    };
    ColorPickerComponent.prototype.save = function () {
        if (typeof this.data.onClose == 'function') {
            this.data.onClose(this.color_picker);
        }
        this.dialogRef.close(this.color_picker);
    };
    ColorPickerComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'ms-color-picker',
                    template: "\n        <button type=\"button\" (click)=\"save()\" mat-raised-button color=\"primary\" style=\"float:right;\">\n            <mat-icon>save</mat-icon> Salvar\n        </button>\n        \n        <mat-select [(ngModel)]=\"defaultNumberColor\" (change)=\"onChangeSelect($event)\" style=\"margin-top:25px; width: calc(100% - 12px);\" placeholder=\"Quantidade de Cores\">\n            <mat-option *ngFor=\"let color of colors\" [value]=\"color.value\">\n                {{ color.title }}\n            </mat-option>\n        </mat-select>\n        \n        <div *ngFor=\"let cp of color_picker\">\n            <md2-colorpicker  #colorPicker\n                              [(ngModel)]=\"cp.color\"\n                              [required]=\"isRequired\"\n                              [disabled]=\"isDisabled\"\n                              [container]=\"container\"\n                              (change)=\"change($event, cp)\"\n                              #colorpickerControl=\"ngModel\">\n            </md2-colorpicker>\n        </div>\n    ",
                    styles: ["\n        :host{\n          padding:15px;\n        }\n    "],
                    providers: []
                },] },
    ];
    /** @nocollapse */
    ColorPickerComponent.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core_1.Inject, args: [material_1.MAT_DIALOG_DATA,] },] },
        { type: material_1.MatDialogRef, },
    ]; };
    ColorPickerComponent.propDecorators = {
        'colorPicker': [{ type: core_1.ViewChild, args: ['colorPicker',] },],
    };
    return ColorPickerComponent;
}());
exports.ColorPickerComponent = ColorPickerComponent;
//# sourceMappingURL=color-picker.component.js.map