"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var color_picker_component_1 = require("./color-picker/color-picker.component");
var material_1 = require("@angular/material");
var rxjs_1 = require("rxjs");
var base_list_1 = require("../base-list");
var services_1 = require("../../../../../services");
var form_element_control_service_1 = require("../../../form-element-control.service");
var list_service_1 = require("../list.service");
var validators_service_1 = require("../../../validators.service");
var masks_service_1 = require("../../../masks.service");
var ListColorComponent = /** @class */ (function (_super) {
    __extends(ListColorComponent, _super);
    function ListColorComponent(dialog, cd, dialogService, controlService, listService, validatorsService, masksService) {
        var _this = _super.call(this, dialog, controlService, listService, validatorsService, masksService) || this;
        _this.dialog = dialog;
        _this.cd = cd;
        _this.dialogService = dialogService;
        _this.controlService = controlService;
        _this.listService = listService;
        _this.validatorsService = validatorsService;
        _this.masksService = masksService;
        return _this;
    }
    ListColorComponent.prototype.onAdding = function () {
        var _self = this;
        return function (tag) {
            var _this = this;
            var accept = !_self.isSelected(tag);
            if (accept) {
                var option = _self.getOption(tag);
                if (!option) {
                    accept = false;
                    var option_1 = _self.newOption(tag);
                    _self.dialog.open(color_picker_component_1.ColorPickerComponent, {
                        panelClass: ['modal-dialog', 'modal-md'],
                        data: {
                            maxColors: 6,
                            onClose: function (res) {
                                if (!_self.config.maxItems || _self.selected.length < _self.config.maxItems) {
                                    option_1.value = res
                                        .map(function (data) {
                                        return data.color;
                                    })
                                        .join(',');
                                    var exists = _self.data.config.attribute.options.items.filter(function (opt) {
                                        return (opt.value == option_1.value);
                                    });
                                    if (exists.length) {
                                        _self.dialogService.error('Já existe uma opção para a cor selecionada!', 'Selecione uma cor diferente ou utilize a opção existente (' + exists[0].label + ')');
                                    }
                                    else {
                                        _this['inputText'] = '';
                                        _this['appendTag'](option_1);
                                        _self.cd.detectChanges();
                                        _self.setSelection(option_1);
                                    }
                                }
                            }
                        }
                    });
                }
                else {
                    tag = option;
                    _self.setSelection(tag);
                }
            }
            return rxjs_1.Observable
                .of(undefined)
                .filter(function () { return accept; })
                .mapTo(tag);
        };
    };
    ListColorComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'ms-list-color',
                    template: "\n        <tag-input\n                [ngModel]=\"selected\"\n                [maxItems]=\"config.maxItems\"\n                [identifyBy]=\"'id'\"\n                [displayBy]=\"'label'\"\n                (onAdd)=\"onAdd($event)\"\n                [onAdding]=\"onAdding()\"\n                [onRemoving]=\"onRemoving()\"\n                [addOnBlur]=\"config.addOnBlur\"\n                [validators]=\"config.validators\"\n                #input>\n\n                <ng-template let-item=\"item\" let-index=\"index\" >\n                    <div style=\"position:relative\">\n                        <form-element-simple-pie [size]=\"20\" [data]='item.value'></form-element-simple-pie>\n                        <span class=\"item-label\" style=\"margin-right:25px;\">{{ item.label }}</span>\n                        <delete-icon (click)=\"input.onRemoving(item)\"></delete-icon>\n                    </div>\n                </ng-template>\n\n            <tag-input-dropdown\n                    [autocompleteItems]=\"options\"\n                    [showDropdownIfEmpty]=\"true\"\n                    [displayBy]=\"'label'\"\n                    [identifyBy]=\"'id'\"\n                    [appendToBody]=\"config.appendToBody\"\n                    [keepOpen]=\"config.keepOpen\"\n                    [focusFirstElement]=\"config.focusFirstElement\">\n\n                <ng-template let-item=\"item\" let-index=\"index2\">\n                    <div style=\"position:relative\">\n                        <form-element-simple-pie [size]=\"20\" [data]='item.value'></form-element-simple-pie>\n                        <span class=\"item-label\">{{ item.label }}</span>\n                    </div>\n                </ng-template>\n\n            </tag-input-dropdown>\n        </tag-input>\n    ",
                    styles: ["\n        .color-into-tag{\n          width: 20px;\n          height: 20px;\n          position: absolute;\n          top: calc(50% - 10px);\n\n          div{\n            position: absolute;\n            width: 50%;\n            height: 50%;\n          }\n        }\n        delete-icon{\n          position: absolute;\n          right: 0;\n          top: 50%;\n          transform: translateY(-50%);\n          height: 34px !important;\n        }\n        delete-icon:hover{\n            transform: scale(1.2) translateY(-14px) !important;\n        }\n        .item-label{\n          margin-left: 25px;\n          line-height: 32px;\n          display:block;\n        }\n    "],
                    providers: []
                },] },
    ];
    /** @nocollapse */
    ListColorComponent.ctorParameters = function () { return [
        { type: material_1.MatDialog, },
        { type: core_1.ChangeDetectorRef, },
        { type: services_1.DialogService, },
        { type: form_element_control_service_1.FormElementControlService, },
        { type: list_service_1.ListService, },
        { type: validators_service_1.ValidatorsService, },
        { type: masks_service_1.MasksService, },
    ]; };
    return ListColorComponent;
}(base_list_1.BaseList));
exports.ListColorComponent = ListColorComponent;
//# sourceMappingURL=list-color.component.js.map