"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
/**

EXAMPLE:
<form-element-simple-pie [size]="100" [data]='[{color: "#f00", value: 10}, {color: "#00f", value: 10}]'></form-element-simple-pie>

 */
var SimplePieComponent = /** @class */ (function () {
    function SimplePieComponent() {
    }
    Object.defineProperty(SimplePieComponent.prototype, "data", {
        get: function () {
            return this.__data;
        },
        set: function (value) {
            if (typeof value == 'string') {
                this.__data = value.split(',').map(function (val) {
                    return {
                        color: val.replace(/\s/g, ''),
                        value: 10
                    };
                });
            }
            else {
                this.__data = value;
            }
        },
        enumerable: true,
        configurable: true
    });
    SimplePieComponent.prototype.ngOnInit = function () {
        var _this = this;
        setTimeout(function () {
            var myTotal = 0;
            for (var _i = 0, _a = _this.data; _i < _a.length; _i++) {
                var item = _a[_i];
                myTotal += item['value'];
            }
            var canvas = _this.canvas.nativeElement;
            var ctx = canvas.getContext("2d");
            var lastend = 0;
            for (var i in _this.data) {
                var item = _this.data[i];
                ctx.fillStyle = item['color'];
                ctx.beginPath();
                ctx.moveTo(canvas.width / 2, canvas.height / 2);
                ctx.arc(canvas.width / 2, canvas.height / 2, canvas.height / 2, lastend, lastend + (Math.PI * 2 * (item['value'] / myTotal)), false);
                ctx.lineTo(canvas.width / 2, canvas.height / 2);
                ctx.fill();
                lastend += Math.PI * 2 * (item['value'] / myTotal);
            }
        }, 500);
    };
    SimplePieComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'form-element-simple-pie',
                    template: "\n        <canvas #can [width]=\"size\" [height]=\"size\" style=\"transform: rotate(90deg); display: block;\"></canvas>\n    ",
                    styles: ["\n        :host{\n          width: 20px;\n          height: 20px;\n          position: absolute;\n          top: 50%;\n          transform: translateY(-50%);\n        }\n    "]
                },] },
    ];
    /** @nocollapse */
    SimplePieComponent.ctorParameters = function () { return []; };
    SimplePieComponent.propDecorators = {
        'canvas': [{ type: core_1.ViewChild, args: ['can',] },],
        'data': [{ type: core_1.Input, args: ['data',] },],
        'size': [{ type: core_1.Input, args: ['size',] },],
    };
    return SimplePieComponent;
}());
exports.SimplePieComponent = SimplePieComponent;
//# sourceMappingURL=simple-pie.component.js.map