"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var base_1 = require("../base");
var forms_1 = require("@angular/forms");
var TextComponent = /** @class */ (function (_super) {
    __extends(TextComponent, _super);
    function TextComponent() {
        var _this = _super.call(this) || this;
        _this.__hasValidatorConfirmed = false;
        _this.__hasValidatorRequired = false;
        return _this;
    }
    TextComponent.prototype.ngOnInit = function () {
        var _this = this;
        _super.prototype.ngOnInit.call(this);
        var validation = (this.data.field.validators || '').split('|');
        validation.forEach(function (validator) {
            if (validator == 'confirmed') {
                _this.__hasValidatorConfirmed = true;
            }
            if (validator == 'required') {
                _this.__hasValidatorRequired = true;
            }
        });
        if (this.__hasValidatorConfirmed) {
            this.data.form.addControl(this.confirmation_field, new forms_1.FormControl(this.confirmation_field, [
                this.validatorsService.getValidator('required'),
                this.validatorsService.getValidator('same', this.data.field.name)
            ]));
        }
    };
    Object.defineProperty(TextComponent.prototype, "confirmation_field", {
        get: function () {
            return this.data.field.name + '_confirmation';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TextComponent.prototype, "type", {
        get: function () {
            var type = this.data.field.type;
            switch (type) {
                case "email":
                    break;
                case "number":
                    break;
                case "password":
                    break;
                case "price":
                    break;
                case "tel":
                    break;
                case "date":
                    break;
                case "time":
                    break;
                case "url":
                    break;
                case "week":
                    break;
                default:
                    type = 'text';
                    break;
            }
            return type;
        },
        enumerable: true,
        configurable: true
    });
    TextComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'gc-form-element-text',
                    template: "\n        <mat-form-field>\n            <input matInput\n               (blur)=\"onBlur($event)\"\n               (change)=\"onChange($event)\"\n               (keyup)=\"onKeyUp($event)\"\n               (keypress)=\"onKeyPress($event)\"\n               [type]=\"type\"\n               [(ngModel)]=\"value\" \n               [formControl]=\"data.formControl\" \n               [placeholder]=\"data.field.placeholder\"\n               [textMask]=\"mask\"\n               [required]=\"__hasValidatorRequired\"\n            />\n            \n            <mat-hint *ngIf=\"hasHint('start')\">{{ getHint('start') }}</mat-hint>\n            <mat-hint *ngIf=\"hasHint('end')\" align=\"end\">{{ getHint('end') }}</mat-hint>\n            \n            <mat-error>\n                <gc-form-element-error [data]=\"data\"></gc-form-element-error>\n            </mat-error>\n        </mat-form-field>\n        \n        <ng-container *ngIf=\"__hasValidatorConfirmed\">\n            \n            <mat-form-field style=\"width:100%\">\n                <input matInput\n                       [type]=\"type\" \n                       [(ngModel)]=\"data.model[confirmation_field]\"\n                       [formControl]=\"data.form.controls[confirmation_field]\"\n                       [placeholder]=\"data.field.placeholder + ' (Confirma\u00E7\u00E3o)'\"\n                       required\n                       >\n                <mat-error>\n                    <div *ngIf=\"data.form.controls[confirmation_field].hasError('notEquivalent')\">\n                        O campo de confirma\u00E7\u00E3o precisa ser igual ao campo {{data.field.placeholder}}.\n                    </div>\n                </mat-error>    \n            </mat-form-field>\n            \n        </ng-container>\n    "
                },] },
    ];
    /** @nocollapse */
    TextComponent.ctorParameters = function () { return []; };
    return TextComponent;
}(base_1.BaseElement));
exports.TextComponent = TextComponent;
//# sourceMappingURL=text.component.js.map