import { ElementRef, OnDestroy, Injector } from '@angular/core';
import { UploaderService } from "./uploader.service";
import { BaseElement } from '../base';
import { Mimetypes } from "./mimetypes";
import { UploaderItemComponent } from "./file.component";
export interface Item {
    status: string;
    selected: boolean;
    index: number;
    file: any;
    fileComponent?: UploaderItemComponent | null;
}
export interface UploaderConfig {
    [key: string]: any;
    info?: string;
    multi?: boolean;
    files?: Array<any>;
    urlParams?: any;
    removable?: boolean;
    deleteMode?: string;
    removeDeletedFiles?: boolean;
    download?: boolean;
    viewMode?: string;
    validators?: {
        types?: string | null;
        size?: number | null;
    };
    gridClass?: string;
    listClass?: string;
    onSuccessfullyUpload?: (data: any) => any;
    writeWith?: (data: any) => void;
    onChange?: (data: any) => void;
    onSelect?: (data: any) => void;
    onRemove?: (data: any) => void;
    uploaderService?: any;
}
export declare class UploaderComponent extends BaseElement implements OnDestroy {
    private injector;
    inputEl: ElementRef;
    items: Array<Item>;
    uploaderService: UploaderService;
    hasChanges: boolean;
    hasPendingUpload: boolean;
    hasOrderChanges: boolean;
    hasSelectedItems: boolean;
    hasUploadFails: boolean;
    intervalCheckFails: any;
    mimeTypes: Mimetypes;
    config: UploaderConfig;
    readonly accept: string;
    constructor(injector: Injector);
    ngOnInit(): void;
    ngOnDestroy(): void;
    parseData(): void;
    normalizeItems(): void;
    viewMode(mode: string): void;
    pickupFiles($event?: any): void;
    upload(event: any): void;
    checkChanges(): void;
    checkPending(): void;
    checkSelected(): void;
    checkUploadFails(): void;
    removeUploadFails(): void;
    writeValue(): void;
    noImageItem(): Item;
    destroySelected(): void;
    onDestroy(item: Item, $event?: any): void;
    onClick(item: Item): void;
    onFailUpload(item: Item, $event: any): void;
    onSuccessfullyUpload(item: Item, $event: any): void;
}
