"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var http_service_1 = require("../../../../services/http.service");
var UploaderService = /** @class */ (function () {
    function UploaderService(httpService) {
        this.httpService = httpService;
        this.headers = httpService.getHeaders();
    }
    UploaderService.prototype.getRoute = function (params) {
        return '/upload';
    };
    UploaderService.prototype.getDeleteRoute = function (file, params) {
        return '/' + (params && params.id ? params.id : '') + '/remove';
    };
    UploaderService.prototype.getHeaders = function () {
        return this.headers;
    };
    UploaderService.prototype.getFieldName = function () {
        return 'file[]';
    };
    UploaderService.prototype.getRequestOptionsArgs = function () {
        return {
            headers: this.getHeaders()
        };
    };
    UploaderService.prototype.getArgs = function () {
        return {
            error: function () { },
            transformJson: false,
            uploadFile: true
        };
    };
    UploaderService.prototype.upload = function (file, urlParams) {
        var data = new FormData();
        data.append(this.getFieldName(), file);
        return this.httpService.post(this.getRoute(urlParams), data, this.getRequestOptionsArgs(), this.getArgs());
    };
    UploaderService.prototype.remove = function (file, urlParams) {
        return this.httpService.delete(this.getDeleteRoute(file, urlParams), this.getRequestOptionsArgs(), this.getArgs());
    };
    UploaderService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    UploaderService.ctorParameters = function () { return [
        { type: http_service_1.HttpService, },
    ]; };
    return UploaderService;
}());
exports.UploaderService = UploaderService;
//# sourceMappingURL=uploader.service.js.map