"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var mimetypes_1 = require("./mimetypes");
var Validator = /** @class */ (function () {
    function Validator() {
        this.errors = [];
        this.mimetypes = new mimetypes_1.Mimetypes();
    }
    Validator.prototype.bytesToSize = function (bytes) {
        var sizes = ['Bytes', 'KB', 'MB', 'GB', 'TB'];
        if (bytes == 0) {
            return '0 Byte';
        }
        var i = Math.floor(Math.log(bytes) / Math.log(1024));
        return Math.round(bytes / Math.pow(1024, i)).toString() + ' ' + sizes[i];
    };
    ;
    Validator.prototype.size = function (file, bytes) {
        if (bytes && file.size > bytes) {
            this.errors.push('Tamanho máximo: ' + this.bytesToSize(bytes));
        }
    };
    Validator.prototype.format = function (file, types) {
        if (types && this.mimetypes.getMimeTypes(types).indexOf(file.type) == -1) {
            this.errors.push('Formatos permitidos: ' + types.join(', ') + '.');
        }
    };
    Validator.prototype.validate = function (file, validators) {
        for (var index in validators) {
            if (typeof this[index] == 'function') {
                this[index](file, validators[index]);
            }
        }
        return this.errors.length ? false : true;
    };
    return Validator;
}());
exports.Validator = Validator;
//# sourceMappingURL=validator.js.map