"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var forms_1 = require("@angular/forms");
var validators_service_1 = require("./validators.service");
var _ = require("lodash");
var FormElementControlService = /** @class */ (function () {
    function FormElementControlService() {
        this.validatorsService = new validators_service_1.ValidatorsService();
    }
    FormElementControlService.prototype.toFormGroup = function (fields) {
        var _this = this;
        var group = {};
        fields.forEach(function (field) {
            var validators = [];
            if (field.validators) {
                if (_.isArray(field.validators)) {
                    validators = field.validators;
                }
                else if (_.isString(field.validators)) {
                    validators = (field.validators || '').split('|');
                }
            }
            group[field.key] = new forms_1.FormControl(field.value || '', _this.validatorsService.getValidators(validators));
        });
        return new forms_1.FormGroup(group);
    };
    FormElementControlService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    FormElementControlService.ctorParameters = function () { return []; };
    return FormElementControlService;
}());
exports.FormElementControlService = FormElementControlService;
//# sourceMappingURL=form-element-control.service.js.map