import { ComponentFactoryResolver, OnInit, OnChanges, SimpleChange, EventEmitter } from '@angular/core';
import { FormControl, FormGroup } from '@angular/forms';
import { Model } from '../../models';
import { FormElementDirective } from './form-element-directive';
import { FormElementService } from './form-element.service';
export interface Option {
    value: string;
    text: string;
}
export interface Element {
    type: string;
    name: string;
    value?: string;
    label?: string;
    placeholder?: string | null;
    options?: Array<any>;
    validators?: any;
    config: ElementConfig;
}
export interface ElementConfig {
    [key: string]: any;
    mask: string;
    unmask?: boolean | null;
    prefix?: string | null;
    suffix?: string | null;
    customClass?: string;
    hint: {
        start: string;
        end: string;
    };
}
export declare class FormElementComponent implements OnInit, OnChanges {
    private componentFactoryResolver;
    private formElementService;
    el: FormElementDirective;
    data: any;
    controlName: string;
    form: FormGroup;
    model: Model;
    modelChange: Model;
    field: Element;
    allowExternalControl: boolean;
    onChange: EventEmitter<any>;
    onKeyUp: EventEmitter<any>;
    onKeyPress: EventEmitter<any>;
    onBlur: EventEmitter<any>;
    hideElement: boolean;
    formControl: FormControl;
    private validatorsService;
    private componentRef;
    constructor(componentFactoryResolver: ComponentFactoryResolver, formElementService: FormElementService);
    ngOnInit(): void;
    ngOnChanges(changes: {
        [propKey: string]: SimpleChange;
    }): void;
    ngAfterContentInit(): void;
    hideWhen(): void;
}
