"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var common_1 = require("@angular/common");
var forms_1 = require("@angular/forms");
var form_element_component_1 = require("./form-element.component");
var form_element_directive_1 = require("./form-element-directive");
var ngx_chips_1 = require("ngx-chips");
var md2_1 = require("md2");
var ng2_ckeditor_1 = require("ng2-ckeditor");
var angular2_text_mask_1 = require("angular2-text-mask");
var form_element_control_service_1 = require("./form-element-control.service");
var masks_service_1 = require("./masks.service");
var validators_service_1 = require("./validators.service");
var form_element_service_1 = require("./form-element.service");
var list_service_1 = require("./elements/tag-input/list.service");
var uploader_service_1 = require("./elements/uploader/uploader.service");
var gc_package_module_1 = require("../../gc-package.module");
var index_1 = require("./elements/index");
var FormElementModule = /** @class */ (function () {
    function FormElementModule() {
    }
    FormElementModule.decorators = [
        { type: core_1.NgModule, args: [{
                    imports: [
                        common_1.CommonModule,
                        forms_1.FormsModule,
                        forms_1.ReactiveFormsModule,
                        ngx_chips_1.TagInputModule,
                        md2_1.Md2Module,
                        angular2_text_mask_1.TextMaskModule,
                        ng2_ckeditor_1.CKEditorModule,
                        gc_package_module_1.GcPackageModule
                    ],
                    declarations: [
                        form_element_directive_1.FormElementDirective,
                        form_element_component_1.FormElementComponent,
                        index_1.ErrorComponent,
                        index_1.CheckboxComponent,
                        index_1.CkeditorComponent,
                        index_1.ColorPickerComponent,
                        index_1.DatepickerComponent,
                        index_1.DatetimeComponent,
                        index_1.ListComponent,
                        index_1.ListColorComponent,
                        index_1.RadioComponent,
                        index_1.SelectComponent,
                        index_1.SimplePieComponent,
                        index_1.SlideToggleComponent,
                        index_1.TextComponent,
                        index_1.TextareaComponent,
                        index_1.UploaderComponent,
                        index_1.UploaderItemComponent
                    ],
                    providers: [
                        form_element_control_service_1.FormElementControlService,
                        form_element_service_1.FormElementService,
                        validators_service_1.ValidatorsService,
                        list_service_1.ListService,
                        uploader_service_1.UploaderService,
                        masks_service_1.MasksService
                    ],
                    exports: [
                        form_element_component_1.FormElementComponent,
                        index_1.ErrorComponent,
                        index_1.TextComponent,
                        index_1.CkeditorComponent,
                        index_1.TextareaComponent,
                        index_1.SelectComponent,
                        index_1.RadioComponent,
                        index_1.CheckboxComponent,
                        index_1.ListComponent,
                        index_1.ListColorComponent,
                        index_1.DatepickerComponent,
                        index_1.DatetimeComponent,
                        index_1.SlideToggleComponent,
                        index_1.UploaderComponent
                    ],
                    entryComponents: [
                        index_1.TextComponent,
                        index_1.TextareaComponent,
                        index_1.SelectComponent,
                        index_1.RadioComponent,
                        index_1.CheckboxComponent,
                        index_1.CkeditorComponent,
                        index_1.ListComponent,
                        index_1.ListColorComponent,
                        index_1.DatepickerComponent,
                        index_1.DatetimeComponent,
                        index_1.SlideToggleComponent,
                        index_1.UploaderComponent,
                        index_1.ColorPickerComponent
                    ],
                },] },
    ];
    /** @nocollapse */
    FormElementModule.ctorParameters = function () { return []; };
    return FormElementModule;
}());
exports.FormElementModule = FormElementModule;
//# sourceMappingURL=form-element.module.js.map