"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var index_1 = require("../../models/index");
var index_2 = require("./elements/index");
var FormElementService = /** @class */ (function () {
    function FormElementService() {
        this.variables = {
            list: {
                Option: index_1.GcOption,
                Options: index_1.GcOptions,
                Attribute: index_1.GcAttribute
            }
        };
        this.components = {
            checkbox: index_2.CheckboxComponent,
            ckeditor: index_2.CkeditorComponent,
            'datepicker': index_2.DatepickerComponent,
            'datetime': index_2.DatetimeComponent,
            list: index_2.ListComponent,
            'list-color': index_2.ListColorComponent,
            radio: index_2.RadioComponent,
            select: index_2.SelectComponent,
            'slide-toggle': index_2.SlideToggleComponent,
            text: index_2.TextComponent,
            textarea: index_2.TextareaComponent,
            uploader: index_2.UploaderComponent
        };
    }
    FormElementService.prototype.getComponentClass = function (name) {
        return this.components[name];
    };
    FormElementService.prototype.addComponentClass = function (name, component) {
        this.components[name] = component;
    };
    FormElementService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    FormElementService.ctorParameters = function () { return []; };
    return FormElementService;
}());
exports.FormElementService = FormElementService;
//# sourceMappingURL=form-element.service.js.map