"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var route_service_1 = require("../services/route.service");
var RouteDirective = /** @class */ (function () {
    function RouteDirective(elem, routeService) {
        this.elem = elem;
        this.routeService = routeService;
    }
    RouteDirective.prototype.ngOnInit = function () {
        this.url = this.routeService.getUrl(this.route);
        if (this.elem.nativeElement.tagName == 'A') {
            this.elem.nativeElement.setAttribute('href', this.url);
        }
    };
    RouteDirective.prototype.onClick = function (event) {
        event.preventDefault();
        this.routeService.navigateByUrl(this.url);
    };
    RouteDirective.decorators = [
        { type: core_1.Directive, args: [{
                    selector: '[route]'
                },] },
    ];
    /** @nocollapse */
    RouteDirective.ctorParameters = function () { return [
        { type: core_1.ElementRef, },
        { type: route_service_1.RouteService, },
    ]; };
    RouteDirective.propDecorators = {
        'route': [{ type: core_1.Input, args: ['route',] },],
        'onClick': [{ type: core_1.HostListener, args: ['click', ['$event'],] },],
    };
    return RouteDirective;
}());
exports.RouteDirective = RouteDirective;
//# sourceMappingURL=route.directive.js.map