"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var model_1 = require("../model");
var option_model_1 = require("./option.model");
var index_1 = require("../../collections/index");
var GcAttribute = /** @class */ (function (_super) {
    __extends(GcAttribute, _super);
    function GcAttribute(data) {
        var _this = _super.call(this, data) || this;
        _this.selectionChange = new core_1.EventEmitter();
        if (typeof _this.options == 'undefined') {
            _this.setOptionsAttribute([]);
        }
        return _this;
    }
    Object.defineProperty(GcAttribute.prototype, "fakeId", {
        get: function () {
            if (!this.__fakeId) {
                this.__fakeId = 'fake_id_' + GcAttribute.__nextId++;
            }
            return this.__fakeId;
        },
        enumerable: true,
        configurable: true
    });
    GcAttribute.prototype.getOptionsClass = function () {
        return option_model_1.GcOptions;
    };
    GcAttribute.prototype.setOptionsAttribute = function (options) {
        var _this = this;
        if (options instanceof this.getOptionsClass()) {
            this.options = options;
        }
        else {
            this.options = (new (this.getOptionsClass())());
            options.forEach(function (option, index) {
                _this.options.add(option);
            });
        }
        this.options.assign(this);
    };
    GcAttribute.prototype.getConfig = function () {
        var config = {};
        if (this.configs) {
            config = this.configs instanceof Object ? this.configs : JSON.parse(this.configs);
        }
        config.attribute = this;
        return config;
    };
    GcAttribute.prototype.getValidators = function () {
        return this.validators ? this.validators.split('|') : [];
    };
    GcAttribute.prototype.hasValidator = function (name) {
        return this.getValidators().indexOf(name) > -1 ? true : false;
    };
    GcAttribute.prototype.addOption = function (option) {
        this.options.add(option);
        return this;
    };
    GcAttribute.prototype.removeOption = function (option) {
        this.options.remove(option);
    };
    GcAttribute.prototype.addSelection = function (option) {
        this.options.addSelection(this, option);
        this.selectionChange.emit(option);
    };
    GcAttribute.prototype.removeSelection = function (index) {
        this.options.removeSelection(this, index);
        this.selectionChange.emit();
    };
    GcAttribute.prototype.clearSelection = function () {
        this.options.clearSelection(this);
        this.selectionChange.emit();
    };
    GcAttribute.prototype.getSelection = function () {
        return this.options.getSelection(this);
    };
    GcAttribute.prototype.all = function () {
        var arr = _super.prototype.all.call(this);
        if (typeof this.options != 'undefined') {
            arr['options'] = this.options.items.map(function (option) {
                return option.all();
            });
        }
        return arr;
    };
    GcAttribute.prototype.getOptionsAvailable = function () {
        return this.options.getOptionsAvailable(this);
    };
    GcAttribute.prototype.getProductOptions = function (product) {
        if (product[this.code]) {
            for (var i = 0, j = this.options.items.length; i < j; i++) {
                if (this.options.items[i].isEqual(product[this.code])) {
                    return this.options.items[i];
                }
            }
        }
        return null;
    };
    GcAttribute.prototype.setSelectionByProduct = function (product) {
        var selected = this.getProductOptions(product);
        if (selected) {
            this.addSelection(selected);
        }
    };
    Object.defineProperty(GcAttribute.prototype, "toFormElement", {
        get: function () {
            return {
                type: this.frontend_type,
                name: this.code,
                label: this.label,
                placeholder: this.label,
                options: this.options.items,
                validators: this.validators,
                config: this.getConfig()
            };
        },
        enumerable: true,
        configurable: true
    });
    GcAttribute.__collection = index_1.GcAttributeCollection;
    GcAttribute.__nextId = 1;
    return GcAttribute;
}(model_1.Model));
exports.GcAttribute = GcAttribute;
//# sourceMappingURL=attribute.model.js.map