import { EventEmitter } from '@angular/core';
import { Model } from '../model';
import { GcAttribute } from './attribute.model';
import { Collection } from "../../collections/collection";
export declare class GcOption extends Model {
    label: string;
    value: string;
    __options: GcOptions;
    __index: number;
    __id: number;
    __fakeId: string;
    static __nextId: number;
    id: any;
    readonly exists: boolean;
    isEqual(data: any): boolean;
    getAttributeCode(): string | undefined;
}
export declare class GcAttributeOptions {
    attribute: GcAttribute;
    selected: Array<GcOption>;
    constructor(attribute: GcAttribute);
    addSelection(option: GcOption): void;
    getSelection(): Array<GcOption>;
    removeSelection(index: number): void;
    clearSelection(): void;
}
export declare class GcOptions extends Collection<any> {
    static _gcOption: typeof GcOption;
    items: Array<GcOption>;
    change: EventEmitter<any>;
    selectionChange: EventEmitter<any>;
    instances: any;
    removeSelectedOptions: boolean;
    code: string;
    constructor(items?: Array<any>);
    assign(attribute: GcAttribute): void;
    getAttributeInstance(attribute: GcAttribute): any;
    add(option: GcOption): void;
    remove(option: GcOption): void;
    addSelection(attribute: GcAttribute, option: GcOption): void;
    getSelection(attribute: GcAttribute): Array<GcOption>;
    removeSelection(attribute: GcAttribute, index: number): void;
    clearSelection(attribute: GcAttribute): void;
    getOptionsAvailable(attribute?: GcAttribute): Array<GcOption>;
    getAttributeCode(): string | undefined;
    readonly length: number;
}
