"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var model_1 = require("../model");
var collection_1 = require("../../collections/collection");
var GcOption = /** @class */ (function (_super) {
    __extends(GcOption, _super);
    function GcOption() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(GcOption.prototype, "id", {
        get: function () {
            if (!this.__fakeId) {
                this.__fakeId = 'fake_id_' + GcOption.__nextId++;
            }
            return this.__id || this.__fakeId;
        },
        set: function (value) {
            this.__id = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(GcOption.prototype, "exists", {
        get: function () {
            return _super.prototype.getId.call(this) ? true : false;
        },
        enumerable: true,
        configurable: true
    });
    GcOption.prototype.isEqual = function (data) {
        if (data) {
            if (typeof data == 'string') {
                if (data == this.value) {
                    return true;
                }
            }
            else if (data.value && data.value == this.value) {
                return true;
            }
        }
        return false;
    };
    GcOption.prototype.getAttributeCode = function () {
        return this.__options.getAttributeCode();
    };
    GcOption.__nextId = 1;
    return GcOption;
}(model_1.Model));
exports.GcOption = GcOption;
var GcAttributeOptions = /** @class */ (function () {
    function GcAttributeOptions(attribute) {
        this.attribute = attribute;
        this.selected = [];
    }
    GcAttributeOptions.prototype.addSelection = function (option) {
        this.selected.push(option);
    };
    GcAttributeOptions.prototype.getSelection = function () {
        return this.selected;
    };
    GcAttributeOptions.prototype.removeSelection = function (index) {
        this.selected = this.selected.filter(function (option) {
            return index != option.__index;
        });
    };
    GcAttributeOptions.prototype.clearSelection = function () {
        this.selected = [];
    };
    return GcAttributeOptions;
}());
exports.GcAttributeOptions = GcAttributeOptions;
var GcOptions = /** @class */ (function (_super) {
    __extends(GcOptions, _super);
    function GcOptions(items) {
        if (items === void 0) { items = []; }
        var _this = _super.call(this, items) || this;
        _this.items = [];
        _this.change = new core_1.EventEmitter();
        _this.selectionChange = new core_1.EventEmitter();
        _this.instances = {};
        _this.removeSelectedOptions = false;
        return _this;
    }
    GcOptions.prototype.assign = function (attribute) {
        this.code = attribute.code;
        if (!this.instances[attribute.fakeId]) {
            this.instances[attribute.fakeId] = new GcAttributeOptions(attribute);
        }
    };
    GcOptions.prototype.getAttributeInstance = function (attribute) {
        this.assign(attribute);
        return this.instances[attribute.fakeId];
    };
    GcOptions.prototype.add = function (option) {
        if (!(option instanceof GcOptions._gcOption)) {
            option = new GcOptions._gcOption(option);
        }
        option.__index = this.items.length;
        option.__options = this;
        this.items.push(option);
        this.change.emit(option);
    };
    GcOptions.prototype.remove = function (option) {
        this.items.slice(option.__index, 1);
        this.change.emit(option);
    };
    GcOptions.prototype.addSelection = function (attribute, option) {
        this.getAttributeInstance(attribute).addSelection(option);
        this.selectionChange.emit();
    };
    GcOptions.prototype.getSelection = function (attribute) {
        return this.getAttributeInstance(attribute).getSelection();
    };
    GcOptions.prototype.removeSelection = function (attribute, index) {
        this.getAttributeInstance(attribute).removeSelection(index);
        this.selectionChange.emit();
    };
    GcOptions.prototype.clearSelection = function (attribute) {
        this.getAttributeInstance(attribute).clearSelection();
        this.selectionChange.emit();
    };
    GcOptions.prototype.getOptionsAvailable = function (attribute) {
        if (this.removeSelectedOptions) {
            var selected_1 = [];
            if (attribute) {
                selected_1 = this.getAttributeInstance(attribute).getSelection();
            }
            else {
                for (var index in this.instances) {
                    selected_1 = selected_1.concat(this.instances[index].getSelection());
                }
            }
            selected_1 = selected_1.map(function (option) {
                return option.id;
            });
            return this.items.filter(function (option) {
                return selected_1.length == 0 || selected_1.indexOf(option.id) == -1;
            });
        }
        return this.items;
    };
    GcOptions.prototype.getAttributeCode = function () {
        if (!this.code) {
            var keys = Object.keys(this.instances);
            if (keys.length) {
                this.code = this.instances[keys[0]].attribute.code;
            }
        }
        return this.code;
    };
    Object.defineProperty(GcOptions.prototype, "length", {
        get: function () {
            return this.items.length;
        },
        enumerable: true,
        configurable: true
    });
    GcOptions._gcOption = GcOption;
    return GcOptions;
}(collection_1.Collection));
exports.GcOptions = GcOptions;
//# sourceMappingURL=option.model.js.map