"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var services_1 = require("../services");
require("rxjs/add/operator/toPromise");
var AuthService = /** @class */ (function () {
    function AuthService(http) {
        this.http = http;
    }
    AuthService.prototype.getUrlLogin = function () {
        return '/access-token';
    };
    AuthService.prototype.getUrlRegister = function () {
        return '/register';
    };
    AuthService.prototype.getUrlUserData = function () {
        return '/user';
    };
    AuthService.prototype.create = function (data, options, args) {
        if (options === void 0) { options = {}; }
        if (!args) {
            args = { throwError: true };
        }
        return this.http.post(this.getUrlRegister(), data, options, args);
    };
    AuthService.prototype.login = function (data, options, args) {
        if (options === void 0) { options = {}; }
        if (!args) {
            args = { throwError: true };
        }
        return this.http.post(this.getUrlLogin(), data, options, args);
    };
    AuthService.prototype.getUser = function (options, args) {
        if (options === void 0) { options = {}; }
        if (!args) {
            args = { throwError: true };
        }
        return this.http.get(this.getUrlUserData(), options, args);
    };
    AuthService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    AuthService.ctorParameters = function () { return [
        { type: services_1.HttpService, },
    ]; };
    return AuthService;
}());
exports.AuthService = AuthService;
//# sourceMappingURL=auth.service.js.map