"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var sweetalert2_1 = require("sweetalert2");
var DialogService = /** @class */ (function () {
    // Documentaion: https://limonte.github.io/sweetalert2/
    function DialogService() {
        sweetalert2_1.default.setDefaults({});
    }
    DialogService.prototype.ngOnInit = function () { };
    DialogService.prototype.show = function (title, message, type) {
        if (type === void 0) { type = undefined; }
        if (typeof title == 'object' && title != null) {
            title.type = type;
            if (typeof title.title != 'string') {
                title.title = '';
            }
            if (typeof title.text != 'string') {
                title.text = '';
            }
            return sweetalert2_1.default(title);
        }
        else {
            return sweetalert2_1.default(title ? title : '', message, type);
        }
    };
    DialogService.prototype.success = function (title, message) {
        return this.show(title, message, 'success');
    };
    DialogService.prototype.error = function (title, message) {
        return this.show(title, message, 'error');
    };
    DialogService.prototype.warning = function (title, message) {
        return this.show(title, message, 'warning');
    };
    DialogService.prototype.info = function (title, message) {
        return this.show(title, message, 'info');
    };
    DialogService.prototype.question = function (title, message) {
        return this.show(title, message, 'question');
    };
    DialogService.prototype.confirm = function (title, message, type) {
        if (type === void 0) { type = 'question'; }
        return this.show({
            title: title,
            text: message,
            type: type,
            showCancelButton: true,
        });
    };
    DialogService.prototype.remove = function (title, message, html) {
        if (title === void 0) { title = 'Are you sure?'; }
        if (message === void 0) { message = "You won't be able to revert this!"; }
        if (html === void 0) { html = false; }
        var obj = {
            title: title,
            type: 'question',
            showCancelButton: true,
            confirmButtonText: 'Yes, delete it!',
            html: '',
            text: '',
        };
        if (html) {
            obj['html'] = message;
            delete obj['text'];
        }
        else {
            obj['text'] = message;
            delete obj['html'];
        }
        return this.show(obj);
    };
    DialogService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    DialogService.ctorParameters = function () { return []; };
    return DialogService;
}());
exports.DialogService = DialogService;
//# sourceMappingURL=dialog.service.js.map