import { Model } from '../models';
import { LocalStorageService, LocationService, RouteService, AuthService } from '../services';
import { CanActivate, ActivatedRouteSnapshot, RouterStateSnapshot } from '@angular/router';
export interface AuthResponse {
    token: {
        [key: string]: any;
    };
    user: any;
}
export declare class GuardService implements CanActivate {
    protected router: RouteService;
    protected authService: AuthService;
    protected localStorageService: LocalStorageService;
    protected locationService: LocationService;
    protected _model: typeof Model;
    protected _allowedUrls: any;
    constructor(router: RouteService, authService: AuthService, localStorageService: LocalStorageService, locationService: LocationService);
    init(): void;
    setAllowedUrls(...routes: string[]): void;
    getAllowedUrls(): Array<string>;
    getRedirectTo(): string;
    getRedirectToUnauthenticated(): string;
    canActivate(route: ActivatedRouteSnapshot, state: RouterStateSnapshot): boolean;
    getAuthService(): AuthService;
    protected getTokenStorageKey(): string;
    protected getUserStorageKey(): string;
    protected afterLogout(): void;
    protected afterLogin(): void;
    loginUsing(response: AuthResponse): void;
    login(params: any, args?: any): Promise<any>;
    create(params: any, args?: any): Promise<any>;
    logout(): void;
    readonly authenticated: boolean;
    token: any;
    user: any;
}
