import { Headers, Http, RequestOptionsArgs, Response } from '@angular/http';
import { DialogService } from './';
import 'rxjs/add/operator/toPromise';
export interface ResponseFormat {
    body: any;
    response: Response;
}
export declare class HttpService {
    http: Http;
    dialog: DialogService;
    apiUrl: string;
    headers: Headers;
    constructor(http: Http, dialog: DialogService);
    init(): void;
    ngAfterViewInit(): void;
    prepareOptions(options?: RequestOptionsArgs): RequestOptionsArgs;
    mergeArgs(args: any): void;
    /**
     *
     * @param response Response
     * @return {any|Xhr}
     */
    getError(data: any): ResponseFormat;
    onError401(error: any): void;
    onError403(error: any): void;
    handleError(response: ResponseFormat): void;
    normalizeRequestBody(body: any): any;
    toSwalFormat(res: any): {
        title: any;
        type: string;
        html: string;
        showCloseButton: boolean;
    };
    setAuthorization(token: string): this;
    setHeaders(name: string, value: string): this;
    getHeaders(): Headers;
    formatResponse(res: any): ResponseFormat;
    get(url: string, options?: RequestOptionsArgs, args?: any): Promise<any>;
    post(url: string, body: any, options?: RequestOptionsArgs, args?: any): Promise<any>;
    put(url: string, body: any, options?: RequestOptionsArgs, args?: any): Promise<any>;
    delete(url: string, options?: RequestOptionsArgs, args?: any): Promise<any>;
}
