"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var LocalStorageService = /** @class */ (function () {
    function LocalStorageService() {
        try {
            this.storage = window.localStorage;
        }
        catch (error) {
            throw error;
        }
    }
    LocalStorageService.prototype.ngOnInit = function () { };
    LocalStorageService.prototype.set = function (key, value) {
        this.storage.setItem(key, (typeof value == 'object' ? JSON.stringify(value) : value));
        return this;
    };
    LocalStorageService.prototype.get = function (key, defaultValue) {
        if (defaultValue === void 0) { defaultValue = null; }
        if (this.storage[key]) {
            try {
                return /^({|\[).*(}|\])$/.test(this.storage[key]) ? JSON.parse(this.storage[key]) : this.storage[key];
            }
            catch (error) {
                return this.storage[key];
            }
        }
        return defaultValue;
    };
    LocalStorageService.prototype.has = function (key) {
        return (this.storage[key] ? true : false);
    };
    LocalStorageService.prototype.remove = function (key) {
        this.storage.removeItem(key);
        return this;
    };
    LocalStorageService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    LocalStorageService.ctorParameters = function () { return []; };
    return LocalStorageService;
}());
exports.LocalStorageService = LocalStorageService;
//# sourceMappingURL=local-storage.service.js.map