"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var router_1 = require("@angular/router");
var common_1 = require("@angular/common");
var LocationService = /** @class */ (function () {
    function LocationService(activatedRoute, location) {
        this.activatedRoute = activatedRoute;
        this.location = location;
    }
    LocationService.prototype.getQueries = function (args) {
        if (args === void 0) { args = {}; }
        this.activatedRoute.queryParams.subscribe(function (params) {
            for (var key in params) {
                if (typeof args[key] == 'undefined') {
                    args[key] = params[key];
                }
            }
        });
        return args;
    };
    LocationService.prototype.replaceState = function (queries, path) {
        if (queries === void 0) { queries = {}; }
        if (!path) {
            path = location.pathname;
        }
        var arr = [];
        for (var key in queries) {
            arr.push(key + '=' + queries[key]);
        }
        this.location.replaceState(path, arr.length ? '?' + arr.join('&') : '');
    };
    LocationService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    LocationService.ctorParameters = function () { return [
        { type: router_1.ActivatedRoute, },
        { type: common_1.Location, },
    ]; };
    return LocationService;
}());
exports.LocationService = LocationService;
//# sourceMappingURL=location.service.js.map